/*!
 * jquery.fancytree.js
 * Tree view control with support for lazy loading and much more.
 * https://github.com/mar10/fancytree/
 *
 * Copyright (c) 2008-2017, Martin Wendt (http://wwWendt.de)
 * Released under the MIT license
 * https://github.com/mar10/fancytree/wiki/LicenseInfo
 *
 * @version 2.25.0
 * @date 2017-10-31T17:32:40Z
 */
!function(a){"function"==typeof define&&define.amd?define(["jquery","./jquery.fancytree.ui-deps"],a):"object"==typeof module&&module.exports?(require("jquery.fancytree.ui-deps"),module.exports=a(require("jquery"))):a(jQuery)}(function(a){"use strict";function b(b,c){b||(c=c?": "+c:"",a.error("Fancytree assertion failed"+c))}function c(a,b){var c,d,e=window.console?window.console[a]:null;if(e)try{e.apply(window.console,b)}catch(f){for(d="",c=0;c<b.length;c++)d+=b[c];e(d)}}function d(a){return!(!a.tree||void 0===a.statusNodeType)}function e(b,c,d,e){var f,g,h,i=a.map(a.trim(b).split("."),function(a){return parseInt(a,10)}),j=a.map(Array.prototype.slice.call(arguments,1),function(a){return parseInt(a,10)});for(f=0;f<j.length;f++)if(g=i[f]||0,h=j[f]||0,g!==h)return g>h;return!0}function f(a,b,c,d,e){var f=function(){var c=b[a],f=d[a],g=b.ext[e],h=function(){return c.apply(b,arguments)},i=function(a){return c.apply(b,a)};return function(){var a=b._local,c=b._super,d=b._superApply;try{return b._local=g,b._super=h,b._superApply=i,f.apply(b,arguments)}finally{b._local=a,b._super=c,b._superApply=d}}}();return f}function g(b,c,d,e){for(var g in d)"function"==typeof d[g]?"function"==typeof b[g]?b[g]=f(g,b,c,d,e):"_"===g.charAt(0)?b.ext[e][g]=f(g,b,c,d,e):a.error("Could not override tree."+g+". Use prefix '_' to create tree."+e+"._"+g):"options"!==g&&(b.ext[e][g]=d[g])}function h(b,c){return void 0===b?a.Deferred(function(){this.resolve()}).promise():a.Deferred(function(){this.resolveWith(b,c)}).promise()}function i(b,c){return void 0===b?a.Deferred(function(){this.reject()}).promise():a.Deferred(function(){this.rejectWith(b,c)}).promise()}function j(a,b){return function(){a.resolveWith(b)}}function k(b){var c=a.extend({},b.data()),d=c.json;return delete c.fancytree,delete c.uiFancytree,d&&(delete c.json,c=a.extend(c,d)),c}function l(a){return(""+a).replace(v,function(a){return x[a]})}function m(a){return a=a.toLowerCase(),function(b){return b.title.toLowerCase().indexOf(a)>=0}}function n(a){var b=new RegExp("^"+a,"i");return function(a){return b.test(a.title)}}function o(c,d){var e,f,g,h;for(this.parent=c,this.tree=c.tree,this.ul=null,this.li=null,this.statusNodeType=null,this._isLoading=!1,this._error=null,this.data={},e=0,f=D.length;e<f;e++)g=D[e],this[g]=d[g];null==this.unselectableIgnore&&null==this.unselectableStatus||(this.unselectable=!0),d.hideCheckbox&&a.error("'hideCheckbox' node option was removed in v2.23.0: use 'checkbox: false'"),d.data&&a.extend(this.data,d.data);for(g in d)E[g]||a.isFunction(d[g])||G[g]||(this.data[g]=d[g]);null==this.key?this.tree.options.defaultKey?(this.key=this.tree.options.defaultKey(this),b(this.key,"defaultKey() must return a unique key")):this.key="_"+s._nextNodeKey++:this.key=""+this.key,d.active&&(b(null===this.tree.activeNode,"only one active node allowed"),this.tree.activeNode=this),d.selected&&(this.tree.lastSelectedNode=this),h=d.children,h?h.length?this._setChildren(h):this.children=this.lazy?[]:null:this.children=null,this.tree._callHook("treeRegisterNode",this.tree,!0,this)}function p(b){this.widget=b,this.$div=b.element,this.options=b.options,this.options&&(a.isFunction(this.options.lazyload)&&!a.isFunction(this.options.lazyLoad)&&(this.options.lazyLoad=function(){return s.warn("The 'lazyload' event is deprecated since 2014-02-25. Use 'lazyLoad' (with uppercase L) instead."),b.options.lazyload.apply(this,arguments)}),a.isFunction(this.options.loaderror)&&a.error("The 'loaderror' event was renamed since 2014-07-03. Use 'loadError' (with uppercase E) instead."),void 0!==this.options.fx&&s.warn("The 'fx' option was replaced by 'toggleEffect' since 2014-11-30."),void 0!==this.options.removeNode&&a.error("The 'removeNode' event was replaced by 'modifyChild' since 2.20 (2016-09-10).")),this.ext={},this.data=k(this.$div),this._id=a.ui.fancytree._nextId++,this._ns=".fancytree-"+this._id,this.activeNode=null,this.focusNode=null,this._hasFocus=null,this._lastMousedownNode=null,this._enableUpdate=!0,this.lastSelectedNode=null,this.systemFocusElement=null,this.lastQuicksearchTerm="",this.lastQuicksearchTime=0,this.statusClassPropName="span",this.ariaPropName="li",this.nodeContainerAttrName="li",this.$div.find(">ul.fancytree-container").remove();var c,d={tree:this};this.rootNode=new o(d,{title:"root",key:"root_"+this._id,children:null,expanded:!0}),this.rootNode.parent=null,c=a("<ul>",{"class":"ui-fancytree fancytree-container fancytree-plain"}).appendTo(this.$div),this.$container=c,this.rootNode.ul=c[0],null==this.options.debugLevel&&(this.options.debugLevel=s.debugLevel)}if(a.ui&&a.ui.fancytree)return void a.ui.fancytree.warn("Fancytree: ignored duplicate include");var q,r,s=null,t=new RegExp(/\.|\//),u=/[&<>"'\/]/g,v=/[<>"'\/]/g,w="$recursive_request",x={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;","/":"&#x2F;"},y={16:!0,17:!0,18:!0},z={8:"backspace",9:"tab",10:"return",13:"return",19:"pause",20:"capslock",27:"esc",32:"space",33:"pageup",34:"pagedown",35:"end",36:"home",37:"left",38:"up",39:"right",40:"down",45:"insert",46:"del",59:";",61:"=",96:"0",97:"1",98:"2",99:"3",100:"4",101:"5",102:"6",103:"7",104:"8",105:"9",106:"*",107:"+",109:"-",110:".",111:"/",112:"f1",113:"f2",114:"f3",115:"f4",116:"f5",117:"f6",118:"f7",119:"f8",120:"f9",121:"f10",122:"f11",123:"f12",144:"numlock",145:"scroll",173:"-",186:";",187:"=",188:",",189:"-",190:".",191:"/",192:"`",219:"[",220:"\\",221:"]",222:"'"},A={0:"",1:"left",2:"middle",3:"right"},B="active expanded focus folder lazy radiogroup selected unselectable unselectableIgnore".split(" "),C={},D="checkbox expanded extraClasses folder icon key lazy radiogroup refKey selected statusNodeType title tooltip unselectable unselectableIgnore unselectableStatus".split(" "),E={},F={},G={active:!0,children:!0,data:!0,focus:!0};for(q=0;q<B.length;q++)C[B[q]]=!0;for(q=0;q<D.length;q++)r=D[q],E[r]=!0,r!==r.toLowerCase()&&(F[r.toLowerCase()]=r);return b(a.ui,"Fancytree requires jQuery UI (http://jqueryui.com)"),o.prototype={_findDirectChild:function(a){var b,c,d=this.children;if(d)if("string"==typeof a){for(b=0,c=d.length;b<c;b++)if(d[b].key===a)return d[b]}else{if("number"==typeof a)return this.children[a];if(a.parent===this)return a}return null},_setChildren:function(a){b(a&&(!this.children||0===this.children.length),"only init supported"),this.children=[];for(var c=0,d=a.length;c<d;c++)this.children.push(new o(this,a[c]))},addChildren:function(c,d){var e,f,g,h=this.getFirstChild(),i=this.getLastChild(),j=null,k=[];for(a.isPlainObject(c)&&(c=[c]),this.children||(this.children=[]),e=0,f=c.length;e<f;e++)k.push(new o(this,c[e]));if(j=k[0],null==d?this.children=this.children.concat(k):(d=this._findDirectChild(d),g=a.inArray(d,this.children),b(g>=0,"insertBefore must be an existing child"),this.children.splice.apply(this.children,[g,0].concat(k))),h&&!d){for(e=0,f=k.length;e<f;e++)k[e].render();h!==this.getFirstChild()&&h.renderStatus(),i!==this.getLastChild()&&i.renderStatus()}else(!this.parent||this.parent.ul||this.tr)&&this.render();return 3===this.tree.options.selectMode&&this.fixSelection3FromEndNodes(),this.triggerModifyChild("add",1===k.length?k[0]:null),j},addClass:function(a){return this.toggleClass(a,!0)},addNode:function(a,c){switch(void 0!==c&&"over"!==c||(c="child"),c){case"after":return this.getParent().addChildren(a,this.getNextSibling());case"before":return this.getParent().addChildren(a,this);case"firstChild":var d=this.children?this.children[0]:null;return this.addChildren(a,d);case"child":case"over":return this.addChildren(a)}b(!1,"Invalid mode: "+c)},addPagingNode:function(b,c){var d,e;if(c=c||"child",b===!1){for(d=this.children.length-1;d>=0;d--)e=this.children[d],"paging"===e.statusNodeType&&this.removeChild(e);return void(this.partload=!1)}return b=a.extend({title:this.tree.options.strings.moreData,statusNodeType:"paging",icon:!1},b),this.partload=!0,this.addNode(b,c)},appendSibling:function(a){return this.addNode(a,"after")},applyPatch:function(b){if(null===b)return this.remove(),h(this);var c,d,e,f={children:!0,expanded:!0,parent:!0};for(c in b)e=b[c],f[c]||a.isFunction(e)||(E[c]?this[c]=e:this.data[c]=e);return b.hasOwnProperty("children")&&(this.removeChildren(),b.children&&this._setChildren(b.children)),this.isVisible()&&(this.renderTitle(),this.renderStatus()),d=b.hasOwnProperty("expanded")?this.setExpanded(b.expanded):h(this)},collapseSiblings:function(){return this.tree._callHook("nodeCollapseSiblings",this)},copyTo:function(a,b,c){return a.addNode(this.toDict(!0,c),b)},countChildren:function(a){var b,c,d,e=this.children;if(!e)return 0;if(d=e.length,a!==!1)for(b=0,c=d;b<c;b++)d+=e[b].countChildren();return d},debug:function(a){this.tree.options.debugLevel>=2&&(Array.prototype.unshift.call(arguments,this.toString()),c("log",arguments))},discard:function(){return this.warn("FancytreeNode.discard() is deprecated since 2014-02-16. Use .resetLazy() instead."),this.resetLazy()},discardMarkup:function(a){var b=a?"nodeRemoveMarkup":"nodeRemoveChildMarkup";this.tree._callHook(b,this)},findAll:function(b){b=a.isFunction(b)?b:m(b);var c=[];return this.visit(function(a){b(a)&&c.push(a)}),c},findFirst:function(b){b=a.isFunction(b)?b:m(b);var c=null;return this.visit(function(a){if(b(a))return c=a,!1}),c},_changeSelectStatusAttrs:function(a){var c=!1,d=this.tree.options,e=s.evalOption("unselectable",this,this,d,!1),f=s.evalOption("unselectableStatus",this,this,d,void 0);switch(e&&null!=f&&(a=f),a){case!1:c=this.selected||this.partsel,this.selected=!1,this.partsel=!1;break;case!0:c=!this.selected||!this.partsel,this.selected=!0,this.partsel=!0;break;case void 0:c=this.selected||!this.partsel,this.selected=!1,this.partsel=!0;break;default:b(!1,"invalid state: "+a)}return c&&this.renderStatus(),c},fixSelection3AfterClick:function(a){var b=this.isSelected();this.visit(function(a){a._changeSelectStatusAttrs(b)}),this.fixSelection3FromEndNodes(a)},fixSelection3FromEndNodes:function(a){function c(a){var b,e,f,g,h,i,j,k,l,m=a.children;if(m&&m.length){for(i=!0,j=!1,b=0,e=m.length;b<e;b++)f=m[b],g=c(f),k=s.evalOption("unselectableIgnore",f,f,d,!1),k||(g!==!1&&(j=!0),g!==!0&&(i=!1));h=!!i||!!j&&void 0}else l=s.evalOption("unselectableStatus",a,a,d,void 0),h=null==l?!!a.selected:!!l;return a._changeSelectStatusAttrs(h),h}var d=this.tree.options;b(3===d.selectMode,"expected selectMode 3"),c(this),this.visitParents(function(a){var b,c,e,f,g,h,i=a.children,j=!0,k=!1;for(b=0,c=i.length;b<c;b++)e=i[b],g=s.evalOption("unselectableIgnore",e,e,d,!1),g||(h=s.evalOption("unselectableStatus",e,e,d,void 0),f=null==h?!!e.selected:!!h,(f||e.partsel)&&(k=!0),f||(j=!1));f=!!j||!!k&&void 0,a._changeSelectStatusAttrs(f)})},fromDict:function(b){for(var c in b)E[c]?this[c]=b[c]:"data"===c?a.extend(this.data,b.data):a.isFunction(b[c])||G[c]||(this.data[c]=b[c]);b.children&&(this.removeChildren(),this.addChildren(b.children)),this.renderTitle()},getChildren:function(){if(void 0!==this.hasChildren())return this.children},getFirstChild:function(){return this.children?this.children[0]:null},getIndex:function(){return a.inArray(this,this.parent.children)},getIndexHier:function(b,c){b=b||".";var d,e=[];return a.each(this.getParentList(!1,!0),function(a,b){d=""+(b.getIndex()+1),c&&(d=("0000000"+d).substr(-c)),e.push(d)}),e.join(b)},getKeyPath:function(a){var b=[],c=this.tree.options.keyPathSeparator;return this.visitParents(function(a){a.parent&&b.unshift(a.key)},!a),c+b.join(c)},getLastChild:function(){return this.children?this.children[this.children.length-1]:null},getLevel:function(){for(var a=0,b=this.parent;b;)a++,b=b.parent;return a},getNextSibling:function(){if(this.parent){var a,b,c=this.parent.children;for(a=0,b=c.length-1;a<b;a++)if(c[a]===this)return c[a+1]}return null},getParent:function(){return this.parent},getParentList:function(a,b){for(var c=[],d=b?this:this.parent;d;)(a||d.parent)&&c.unshift(d),d=d.parent;return c},getPrevSibling:function(){if(this.parent){var a,b,c=this.parent.children;for(a=1,b=c.length;a<b;a++)if(c[a]===this)return c[a-1]}return null},getSelectedNodes:function(a){var b=[];return this.visit(function(c){if(c.selected&&(b.push(c),a===!0))return"skip"}),b},hasChildren:function(){if(this.lazy){if(null==this.children)return;if(0===this.children.length)return!1;if(1===this.children.length&&this.children[0].isStatusNode())return;return!0}return!(!this.children||!this.children.length)},hasFocus:function(){return this.tree.hasFocus()&&this.tree.focusNode===this},info:function(a){this.tree.options.debugLevel>=1&&(Array.prototype.unshift.call(arguments,this.toString()),c("info",arguments))},isActive:function(){return this.tree.activeNode===this},isChildOf:function(a){return this.parent&&this.parent===a},isDescendantOf:function(b){if(!b||b.tree!==this.tree)return!1;for(var c=this.parent;c;){if(c===b)return!0;c===c.parent&&a.error("Recursive parent link: "+c),c=c.parent}return!1},isExpanded:function(){return!!this.expanded},isFirstSibling:function(){var a=this.parent;return!a||a.children[0]===this},isFolder:function(){return!!this.folder},isLastSibling:function(){var a=this.parent;return!a||a.children[a.children.length-1]===this},isLazy:function(){return!!this.lazy},isLoaded:function(){return!this.lazy||void 0!==this.hasChildren()},isLoading:function(){return!!this._isLoading},isRoot:function(){return this.isRootNode()},isPartsel:function(){return!this.selected&&!!this.partsel},isPartload:function(){return!!this.partload},isRootNode:function(){return this.tree.rootNode===this},isSelected:function(){return!!this.selected},isStatusNode:function(){return!!this.statusNodeType},isPagingNode:function(){return"paging"===this.statusNodeType},isTopLevel:function(){return this.tree.rootNode===this.parent},isUndefined:function(){return void 0===this.hasChildren()},isVisible:function(){var a,b,c=this.getParentList(!1,!1);for(a=0,b=c.length;a<b;a++)if(!c[a].expanded)return!1;return!0},lazyLoad:function(a){return this.warn("FancytreeNode.lazyLoad() is deprecated since 2014-02-16. Use .load() instead."),this.load(a)},load:function(a){var c,d,e=this,f=this.isExpanded();return b(this.isLazy(),"load() requires a lazy node"),a||this.isUndefined()?(this.isLoaded()&&this.resetLazy(),d=this.tree._triggerNodeEvent("lazyLoad",this),d===!1?h(this):(b("boolean"!=typeof d,"lazyLoad event must return source in data.result"),c=this.tree._callHook("nodeLoadChildren",this,d),f?(this.expanded=!0,c.always(function(){e.render()})):c.always(function(){e.renderStatus()}),c)):h(this)},makeVisible:function(b){var c,d=this,e=[],f=new a.Deferred,g=this.getParentList(!1,!1),h=g.length,i=!(b&&b.noAnimation===!0),j=!(b&&b.scrollIntoView===!1);for(c=h-1;c>=0;c--)e.push(g[c].setExpanded(!0,b));return a.when.apply(a,e).done(function(){j?d.scrollIntoView(i).done(function(){f.resolve()}):f.resolve()}),f.promise()},moveTo:function(c,d,e){void 0===d||"over"===d?d="child":"firstChild"===d&&(c.children&&c.children.length?(d="before",c=c.children[0]):d="child");var f,g=this.parent,h="child"===d?c:c.parent;if(this!==c){if(this.parent?h.isDescendantOf(this)&&a.error("Cannot move a node to its own descendant"):a.error("Cannot move system root"),h!==g&&g.triggerModifyChild("remove",this),1===this.parent.children.length){if(this.parent===h)return;this.parent.children=this.parent.lazy?[]:null,this.parent.expanded=!1}else f=a.inArray(this,this.parent.children),b(f>=0,"invalid source parent"),this.parent.children.splice(f,1);if(this.parent=h,h.hasChildren())switch(d){case"child":h.children.push(this);break;case"before":f=a.inArray(c,h.children),b(f>=0,"invalid target parent"),h.children.splice(f,0,this);break;case"after":f=a.inArray(c,h.children),b(f>=0,"invalid target parent"),h.children.splice(f+1,0,this);break;default:a.error("Invalid mode "+d)}else h.children=[this];e&&c.visit(e,!0),h===g?h.triggerModifyChild("move",this):h.triggerModifyChild("add",this),this.tree!==c.tree&&(this.warn("Cross-tree moveTo is experimantal!"),this.visit(function(a){a.tree=c.tree},!0)),g.isDescendantOf(h)||g.render(),h.isDescendantOf(g)||h===g||h.render()}},navigate:function(b,c){function d(d){if(d){try{d.makeVisible({scrollIntoView:!1})}catch(e){}return a(d.span).is(":visible")?c===!1?d.setFocus():d.setActive():(d.debug("Navigate: skipping hidden node"),void d.navigate(b,c))}}var e,f,g,i=!0,j=a.ui.keyCode,k=null;switch(b){case j.BACKSPACE:this.parent&&this.parent.parent&&(g=d(this.parent));break;case j.HOME:this.tree.visit(function(b){if(a(b.span).is(":visible"))return g=d(b),!1});break;case j.END:this.tree.visit(function(b){a(b.span).is(":visible")&&(g=b)}),g&&(g=d(g));break;case j.LEFT:this.expanded?(this.setExpanded(!1),g=d(this)):this.parent&&this.parent.parent&&(g=d(this.parent));break;case j.RIGHT:this.expanded||!this.children&&!this.lazy?this.children&&this.children.length&&(g=d(this.children[0])):(this.setExpanded(),g=d(this));break;case j.UP:for(k=this.getPrevSibling();k&&!a(k.span).is(":visible");)k=k.getPrevSibling();for(;k&&k.expanded&&k.children&&k.children.length;)k=k.children[k.children.length-1];!k&&this.parent&&this.parent.parent&&(k=this.parent),g=d(k);break;case j.DOWN:if(this.expanded&&this.children&&this.children.length)k=this.children[0];else for(f=this.getParentList(!1,!0),e=f.length-1;e>=0;e--){for(k=f[e].getNextSibling();k&&!a(k.span).is(":visible");)k=k.getNextSibling();if(k)break}g=d(k);break;default:i=!1}return g||h()},remove:function(){return this.parent.removeChild(this)},removeChild:function(a){return this.tree._callHook("nodeRemoveChild",this,a)},removeChildren:function(){return this.tree._callHook("nodeRemoveChildren",this)},removeClass:function(a){return this.toggleClass(a,!1)},render:function(a,b){return this.tree._callHook("nodeRender",this,a,b)},renderTitle:function(){return this.tree._callHook("nodeRenderTitle",this)},renderStatus:function(){return this.tree._callHook("nodeRenderStatus",this)},replaceWith:function(c){var d,e=this.parent,f=a.inArray(this,e.children),g=this;return b(this.isPagingNode(),"replaceWith() currently requires a paging status node"),d=this.tree._callHook("nodeLoadChildren",this,c),d.done(function(a){var b=g.children;for(q=0;q<b.length;q++)b[q].parent=e;e.children.splice.apply(e.children,[f+1,0].concat(b)),g.children=null,g.remove(),e.render()}).fail(function(){g.setExpanded()}),d},resetLazy:function(){this.removeChildren(),this.expanded=!1,this.lazy=!0,this.children=void 0,this.renderStatus()},scheduleAction:function(b,c){this.tree.timer&&clearTimeout(this.tree.timer),this.tree.timer=null;var d=this;switch(b){case"cancel":break;case"expand":this.tree.timer=setTimeout(function(){d.tree.debug("setTimeout: trigger expand"),d.setExpanded(!0)},c);break;case"activate":this.tree.timer=setTimeout(function(){d.tree.debug("setTimeout: trigger activate"),d.setActive(!0)},c);break;default:a.error("Invalid mode "+b)}},scrollIntoView:function(c,e){void 0!==e&&d(e)&&(this.warn("scrollIntoView() with 'topNode' option is deprecated since 2014-05-08. Use 'options.topNode' instead."),e={topNode:e});var f,g,i,j,k=a.extend({effects:c===!0?{duration:200,queue:!1}:c,scrollOfs:this.tree.options.scrollOfs,scrollParent:this.tree.options.scrollParent||this.tree.$container,topNode:null},e),l=new a.Deferred,m=this,n=a(this.span).height(),o=a(k.scrollParent),p=k.scrollOfs.top||0,q=k.scrollOfs.bottom||0,r=o.height(),s=o.scrollTop(),t=o,u=o[0]===window,v=k.topNode||null,w=null;return a(this.span).is(":visible")?(u?(g=a(this.span).offset().top,f=v&&v.span?a(v.span).offset().top:0,t=a("html,body")):(b(o[0]!==document&&o[0]!==document.body,"scrollParent should be a simple element or `window`, not document or body."),j=o.offset().top,g=a(this.span).offset().top-j+s,f=v?a(v.span).offset().top-j+s:0,i=Math.max(0,o.innerHeight()-o[0].clientHeight),r-=i),g<s+p?w=g-p:g+n>s+r-q&&(w=g+n-r+q,v&&(b(v.isRootNode()||a(v.span).is(":visible"),"topNode must be visible"),f<w&&(w=f-p))),null!==w?k.effects?(k.effects.complete=function(){l.resolveWith(m)},t.stop(!0).animate({scrollTop:w},k.effects)):(t[0].scrollTop=w,l.resolveWith(this)):l.resolveWith(this),l.promise()):(this.warn("scrollIntoView(): node is invisible."),h())},setActive:function(a,b){return this.tree._callHook("nodeSetActive",this,a,b)},setExpanded:function(a,b){return this.tree._callHook("nodeSetExpanded",this,a,b)},setFocus:function(a){return this.tree._callHook("nodeSetFocus",this,a)},setSelected:function(a,b){return this.tree._callHook("nodeSetSelected",this,a,b)},setStatus:function(a,b,c){return this.tree._callHook("nodeSetStatus",this,a,b,c)},setTitle:function(a){this.title=a,this.renderTitle(),this.triggerModify("rename")},sortChildren:function(a,b){var c,d,e=this.children;if(e){if(a=a||function(a,b){var c=a.title.toLowerCase(),d=b.title.toLowerCase();return c===d?0:c>d?1:-1},e.sort(a),b)for(c=0,d=e.length;c<d;c++)e[c].children&&e[c].sortChildren(a,"$norender$");"$norender$"!==b&&this.render(),this.triggerModifyChild("sort")}},toDict:function(b,c){var d,e,f,g={},h=this;if(a.each(D,function(a,b){(h[b]||h[b]===!1)&&(g[b]=h[b])}),a.isEmptyObject(this.data)||(g.data=a.extend({},this.data),a.isEmptyObject(g.data)&&delete g.data),c&&c(g,h),b&&this.hasChildren())for(g.children=[],d=0,e=this.children.length;d<e;d++)f=this.children[d],f.isStatusNode()||g.children.push(f.toDict(!0,c));return g},toggleClass:function(b,c){var d,e,f=/\S+/g,g=b.match(f)||[],h=0,i=!1,j=this[this.tree.statusClassPropName],k=" "+(this.extraClasses||"")+" ";for(j&&a(j).toggleClass(b,c);d=g[h++];)if(e=k.indexOf(" "+d+" ")>=0,c=void 0===c?!e:!!c)e||(k+=d+" ",i=!0);else for(;k.indexOf(" "+d+" ")>-1;)k=k.replace(" "+d+" "," ");return this.extraClasses=a.trim(k),i},toggleExpanded:function(){return this.tree._callHook("nodeToggleExpanded",this)},toggleSelected:function(){return this.tree._callHook("nodeToggleSelected",this)},toString:function(){return"<FancytreeNode(#"+this.key+", '"+this.title+"')>"},triggerModifyChild:function(b,c,d){var e,f=this.tree.options.modifyChild;f&&(c&&c.parent!==this&&a.error("childNode "+c+" is not a child of "+this),e={node:this,tree:this.tree,operation:b,childNode:c||null},d&&a.extend(e,d),f({type:"modifyChild"},e))},triggerModify:function(a,b){this.parent.triggerModifyChild(a,this,b)},visit:function(a,b){var c,d,e=!0,f=this.children;if(b===!0&&(e=a(this),e===!1||"skip"===e))return e;if(f)for(c=0,d=f.length;c<d&&(e=f[c].visit(a,!0),e!==!1);c++);return e},visitAndLoad:function(b,c,d){var e,f,g,i=this;return b&&c===!0&&(f=b(i),f===!1||"skip"===f)?d?f:h():i.children||i.lazy?(e=new a.Deferred,g=[],i.load().done(function(){for(var c=0,d=i.children.length;c<d;c++){if(f=i.children[c].visitAndLoad(b,!0,!0),f===!1){e.reject();break}"skip"!==f&&g.push(f)}a.when.apply(this,g).then(function(){e.resolve()})}),e.promise()):h()},visitParents:function(a,b){if(b&&a(this)===!1)return!1;for(var c=this.parent;c;){if(a(c)===!1)return!1;c=c.parent}return!0},visitSiblings:function(a,b){var c,d,e,f=this.parent.children;for(c=0,d=f.length;c<d;c++)if(e=f[c],(b||e!==this)&&a(e)===!1)return!1;return!0},warn:function(a){Array.prototype.unshift.call(arguments,this.toString()),c("warn",arguments)}},p.prototype={_makeHookContext:function(b,c,d){var e,f;return void 0!==b.node?(c&&b.originalEvent!==c&&a.error("invalid args"),e=b):b.tree?(f=b.tree,e={node:b,tree:f,widget:f.widget,options:f.widget.options,originalEvent:c}):b.widget?e={node:null,tree:b,widget:b.widget,options:b.widget.options,originalEvent:c}:a.error("invalid args"),d&&a.extend(e,d),e},_callHook:function(b,c,d){var e=this._makeHookContext(c),f=this[b],g=Array.prototype.slice.call(arguments,2);return a.isFunction(f)||a.error("_callHook('"+b+"') is not a function"),g.unshift(e),f.apply(this,g)},_requireExtension:function(c,d,e,f){e=!!e;var g=this._local.name,h=this.options.extensions,i=a.inArray(c,h)<a.inArray(g,h),j=d&&null==this.ext[c],k=!j&&null!=e&&e!==i;return b(g&&g!==c,"invalid or same name"),!j&&!k||(f||(j||d?(f="'"+g+"' extension requires '"+c+"'",k&&(f+=" to be registered "+(e?"before":"after")+" itself")):f="If used together, `"+c+"` must be registered "+(e?"before":"after")+" `"+g+"`"),a.error(f),!1)},activateKey:function(a){var b=this.getNodeByKey(a);return b?b.setActive():this.activeNode&&this.activeNode.setActive(!1),b},addPagingNode:function(a,b){return this.rootNode.addPagingNode(a,b)},applyPatch:function(c){var d,e,f,g,h,i,k=c.length,l=[];for(e=0;e<k;e++)f=c[e],b(2===f.length,"patchList must be an array of length-2-arrays"),g=f[0],h=f[1],i=null===g?this.rootNode:this.getNodeByKey(g),i?(d=new a.Deferred,l.push(d),i.applyPatch(h).always(j(d,i))):this.warn("could not find node with key '"+g+"'");return a.when.apply(a,l).promise()},clear:function(a){this._callHook("treeClear",this)},count:function(){return this.rootNode.countChildren()},debug:function(a){this.options.debugLevel>=2&&(Array.prototype.unshift.call(arguments,this.toString()),c("log",arguments))},enableUpdate:function(a){return a=a!==!1,!!this._enableUpdate==!!a?a:(this._enableUpdate=a,a?(this.debug("enableUpdate(true): redraw "),this.render()):this.debug("enableUpdate(false)..."),!a)},findAll:function(a){return this.rootNode.findAll(a)},findFirst:function(a){return this.rootNode.findFirst(a)},findNextNode:function(b,c,d){var e=null,f=c.parent.children,g=null,h=function(a,b,c){var d,e,f=a.children,g=f.length,i=f[b];if(i&&c(i)===!1)return!1;if(i&&i.children&&i.expanded&&h(i,0,c)===!1)return!1;for(d=b+1;d<g;d++)if(h(a,d,c)===!1)return!1;return e=a.parent,e?h(e,e.children.indexOf(a)+1,c):h(a,0,c)};return b="string"==typeof b?n(b):b,c=c||this.getFirstChild(),h(c.parent,f.indexOf(c),function(d){return d!==e&&(e=e||d,a(d.span).is(":visible")?(!b(d)||(g=d,g===c))&&void 0:void d.debug("quicksearch: skipping hidden node"))}),g},generateFormElements:function(b,c,d){function e(b){j.append(a("<input>",{type:"checkbox",name:g,value:b.key,checked:!0}))}d=d||{};var f,g="string"==typeof b?b:"ft_"+this._id+"[]",h="string"==typeof c?c:"ft_"+this._id+"_active",i="fancytree_result_"+this._id,j=a("#"+i),k=3===this.options.selectMode&&d.stopOnParents!==!1;j.length?j.empty():j=a("<div>",{id:i}).hide().insertAfter(this.$container),c!==!1&&this.activeNode&&j.append(a("<input>",{type:"radio",name:h,value:this.activeNode.key,checked:!0})),d.filter?this.visit(function(a){var b=d.filter(a);return"skip"===b?b:void(b!==!1&&e(a))}):b!==!1&&(f=this.getSelectedNodes(k),a.each(f,function(a,b){e(b)}))},getActiveNode:function(){return this.activeNode},getFirstChild:function(){return this.rootNode.getFirstChild()},getFocusNode:function(){return this.focusNode},getNodeByKey:function(a,b){var c,d;return!b&&(c=document.getElementById(this.options.idPrefix+a))?c.ftnode?c.ftnode:null:(b=b||this.rootNode,d=null,b.visit(function(b){if(b.key===a)return d=b,!1},!0),d)},getRootNode:function(){return this.rootNode},getSelectedNodes:function(a){return this.rootNode.getSelectedNodes(a)},hasFocus:function(){return!!this._hasFocus},info:function(a){this.options.debugLevel>=1&&(Array.prototype.unshift.call(arguments,this.toString()),c("info",arguments))},loadKeyPath:function(b,c,d){function e(a,b,d){c.call(q,b,"loading"),b.load().done(function(){q.loadKeyPath.call(q,l[a],c,b).always(j(d,q))}).fail(function(e){q.warn("loadKeyPath: error loading: "+a+" (parent: "+n+")"),c.call(q,b,"error"),d.reject()})}var f,g,h,i,k,l,m,n,o,p=this.options.keyPathSeparator,q=this;for(c=c||a.noop,a.isArray(b)||(b=[b]),l={},h=0;h<b.length;h++)for(n=d||this.rootNode,i=b[h],i.charAt(0)===p&&(i=i.substr(1)),o=i.split(p);o.length;){if(k=o.shift(),m=n._findDirectChild(k),!m){this.warn("loadKeyPath: key not found: "+k+" (parent: "+n+")"),c.call(this,k,"error");break}if(0===o.length){c.call(this,m,"ok");break}if(m.lazy&&void 0===m.hasChildren()){c.call(this,m,"loaded"),l[k]?l[k].push(o.join(p)):l[k]=[o.join(p)];break}c.call(this,m,"loaded"),n=m}f=[];for(k in l)m=n._findDirectChild(k),null==m&&(m=q.getNodeByKey(k)),g=new a.Deferred,f.push(g),e(k,m,g);return a.when.apply(a,f).promise()},reactivate:function(a){var b,c=this.activeNode;return c?(this.activeNode=null,b=c.setActive(!0,{noFocus:!0}),a&&c.setFocus(),b):h()},reload:function(a){return this._callHook("treeClear",this),this._callHook("treeLoad",this,a)},render:function(a,b){return this.rootNode.render(a,b)},setFocus:function(a){return this._callHook("treeSetFocus",this,a)},toDict:function(a,b){var c=this.rootNode.toDict(!0,b);return a?c:c.children},toString:function(){return"<Fancytree(#"+this._id+")>"},_triggerNodeEvent:function(a,b,c,d){var e=this._makeHookContext(b,c,d),f=this.widget._trigger(a,c,e);return f!==!1&&void 0!==e.result?e.result:f},_triggerTreeEvent:function(a,b,c){var d=this._makeHookContext(this,b,c),e=this.widget._trigger(a,b,d);return e!==!1&&void 0!==d.result?d.result:e},visit:function(a){return this.rootNode.visit(a,!1)},warn:function(a){Array.prototype.unshift.call(arguments,this.toString()),c("warn",arguments)}},a.extend(p.prototype,{nodeClick:function(a){var b,c,d=a.targetType,e=a.node;if("expander"===d){if(e.isLoading())return void e.debug("Got 2nd click while loading: ignored");this._callHook("nodeToggleExpanded",a)}else if("checkbox"===d)this._callHook("nodeToggleSelected",a),a.options.focusOnSelect&&this._callHook("nodeSetFocus",a,!0);else{if(c=!1,b=!0,e.folder)switch(a.options.clickFolderMode){case 2:c=!0,b=!1;break;case 3:b=!0,c=!0}b&&(this.nodeSetFocus(a),this._callHook("nodeSetActive",a,!0)),c&&this._callHook("nodeToggleExpanded",a)}},nodeCollapseSiblings:function(a,b){var c,d,e,f=a.node;if(f.parent)for(c=f.parent.children,d=0,e=c.length;d<e;d++)c[d]!==f&&c[d].expanded&&this._callHook("nodeSetExpanded",c[d],!1,b)},nodeDblclick:function(a){"title"===a.targetType&&4===a.options.clickFolderMode&&this._callHook("nodeToggleExpanded",a),"title"===a.targetType&&a.originalEvent.preventDefault()},nodeKeydown:function(b){var c,d,e,f,g=b.originalEvent,h=b.node,i=b.tree,j=b.options,k=g.which,l=String.fromCharCode(k),m=!(g.altKey||g.ctrlKey||g.metaKey||g.shiftKey),n=a(g.target),o=!0,p=!(g.ctrlKey||!j.autoActivate);if(h||(f=this.getActiveNode()||this.getFirstChild(),f&&(f.setFocus(),h=b.node=this.focusNode,h.debug("Keydown force focus on active node"))),j.quicksearch&&m&&/\w/.test(l)&&!z[k]&&!n.is(":input:enabled"))return d=(new Date).getTime(),d-i.lastQuicksearchTime>500&&(i.lastQuicksearchTerm=""),i.lastQuicksearchTime=d,i.lastQuicksearchTerm+=l,c=i.findNextNode(i.lastQuicksearchTerm,i.getActiveNode()),c&&c.setActive(),void g.preventDefault();switch(s.eventToString(g)){case"+":case"=":i.nodeSetExpanded(b,!0);break;case"-":i.nodeSetExpanded(b,!1);break;case"space":h.isPagingNode()?i._triggerNodeEvent("clickPaging",b,g):s.evalOption("checkbox",h,h,j,!1)?i.nodeToggleSelected(b):i.nodeSetActive(b,!0);break;case"return":i.nodeSetActive(b,!0);break;case"home":case"end":case"backspace":case"left":case"right":case"up":case"down":e=h.navigate(g.which,p,!0);break;default:o=!1}o&&g.preventDefault()},nodeLoadChildren:function(c,d){var e,f,g,h=c.tree,i=c.node,j=(new Date).getTime();return a.isFunction(d)&&(d=d.call(h,{type:"source"},c),b(!a.isFunction(d),"source callback must not return another function")),d.url&&(i._requestId&&i.warn("Recursive load request #"+j+" while #"+i._requestId+" is pending."),e=a.extend({},c.options.ajax,d),i._requestId=j,e.debugDelay?(f=e.debugDelay,a.isArray(f)&&(f=f[0]+Math.random()*(f[1]-f[0])),i.warn("nodeLoadChildren waiting debugDelay "+Math.round(f)+" ms ..."),e.debugDelay=!1,g=a.Deferred(function(b){setTimeout(function(){a.ajax(e).done(function(){b.resolveWith(this,arguments)}).fail(function(){b.rejectWith(this,arguments)})},f)})):g=a.ajax(e),d=new a.Deferred,g.done(function(b,e,f){var g,k;if("json"!==this.dataType&&"jsonp"!==this.dataType||"string"!=typeof b||a.error("Ajax request returned a string (did you get the JSON dataType wrong?)."),i._requestId&&i._requestId>j)return void d.rejectWith(this,[w]);if(c.options.postProcess){try{k=h._triggerNodeEvent("postProcess",c,c.originalEvent,{response:b,error:null,dataType:this.dataType})}catch(l){k={error:l,message:""+l,details:"postProcess failed"}}if(k.error)return g=a.isPlainObject(k.error)?k.error:{
message:k.error},g=h._makeHookContext(i,null,g),void d.rejectWith(this,[g]);b=a.isArray(k)?k:b}else b&&b.hasOwnProperty("d")&&c.options.enableAspx&&(b="string"==typeof b.d?a.parseJSON(b.d):b.d);d.resolveWith(this,[b])}).fail(function(a,b,c){var e=h._makeHookContext(i,null,{error:a,args:Array.prototype.slice.call(arguments),message:c,details:a.status+": "+c});d.rejectWith(this,[e])})),a.isFunction(d.then)&&a.isFunction(d["catch"])&&(g=d,d=new a.Deferred,g.then(function(a){d.resolve(a)},function(a){d.reject(a)})),a.isFunction(d.promise)&&(h.nodeSetStatus(c,"loading"),d.done(function(a){h.nodeSetStatus(c,"ok"),i._requestId=null}).fail(function(a){var b;return a===w?void i.warn("Ignored response for obsolete load request #"+j+" (expected #"+i._requestId+")"):(a.node&&a.error&&a.message?b=a:(b=h._makeHookContext(i,null,{error:a,args:Array.prototype.slice.call(arguments),message:a?a.message||a.toString():""}),"[object Object]"===b.message&&(b.message="")),i.warn("Load children failed ("+b.message+")",b),void(h._triggerNodeEvent("loadError",b,null)!==!1&&h.nodeSetStatus(c,"error",b.message,b.details)))})),a.when(d).done(function(c){var d;a.isPlainObject(c)&&(b(i.isRootNode(),"source may only be an object for root nodes (expecting an array of child objects otherwise)"),b(a.isArray(c.children),"if an object is passed as source, it must contain a 'children' array (all other properties are added to 'tree.data')"),d=c,c=c.children,delete d.children,a.extend(h.data,d)),b(a.isArray(c),"expected array of children"),i._setChildren(c),h._triggerNodeEvent("loadChildren",i)})},nodeLoadKeyPath:function(a,b){},nodeRemoveChild:function(c,d){var e,f=c.node,g=a.extend({},c,{node:d}),h=f.children;return 1===h.length?(b(d===h[0],"invalid single child"),this.nodeRemoveChildren(c)):(this.activeNode&&(d===this.activeNode||this.activeNode.isDescendantOf(d))&&this.activeNode.setActive(!1),this.focusNode&&(d===this.focusNode||this.focusNode.isDescendantOf(d))&&(this.focusNode=null),this.nodeRemoveMarkup(g),this.nodeRemoveChildren(g),e=a.inArray(d,h),b(e>=0,"invalid child"),f.triggerModifyChild("remove",d),d.visit(function(a){a.parent=null},!0),this._callHook("treeRegisterNode",this,!1,d),void h.splice(e,1))},nodeRemoveChildMarkup:function(b){var c=b.node;c.ul&&(c.isRootNode()?a(c.ul).empty():(a(c.ul).remove(),c.ul=null),c.visit(function(a){a.li=a.ul=null}))},nodeRemoveChildren:function(b){var c,d=b.tree,e=b.node,f=e.children;f&&(this.activeNode&&this.activeNode.isDescendantOf(e)&&this.activeNode.setActive(!1),this.focusNode&&this.focusNode.isDescendantOf(e)&&(this.focusNode=null),this.nodeRemoveChildMarkup(b),c=a.extend({},b),e.triggerModifyChild("remove",null),e.visit(function(a){a.parent=null,d._callHook("treeRegisterNode",d,!1,a)}),e.lazy?e.children=[]:e.children=null,e.isRootNode()||(e.expanded=!1),this.nodeRenderStatus(b))},nodeRemoveMarkup:function(b){var c=b.node;c.li&&(a(c.li).remove(),c.li=null),this.nodeRemoveChildMarkup(b)},nodeRender:function(c,d,e,f,g){var h,i,j,k,l,m,n,o=c.node,p=c.tree,q=c.options,r=q.aria,s=!1,t=o.parent,u=!t,v=o.children,w=null;if(p._enableUpdate!==!1&&(u||t.ul)){if(b(u||t.ul,"parent UL must exist"),u||(o.li&&(d||o.li.parentNode!==o.parent.ul)&&(o.li.parentNode===o.parent.ul?w=o.li.nextSibling:this.debug("Unlinking "+o+" (must be child of "+o.parent+")"),this.nodeRemoveMarkup(c)),o.li?this.nodeRenderStatus(c):(s=!0,o.li=document.createElement("li"),o.li.ftnode=o,o.key&&q.generateIds&&(o.li.id=q.idPrefix+o.key),o.span=document.createElement("span"),o.span.className="fancytree-node",r&&!o.tr&&a(o.li).attr("role","treeitem"),o.li.appendChild(o.span),this.nodeRenderTitle(c),q.createNode&&q.createNode.call(p,{type:"createNode"},c)),q.renderNode&&q.renderNode.call(p,{type:"renderNode"},c)),v){if(u||o.expanded||e===!0){for(o.ul||(o.ul=document.createElement("ul"),(f!==!0||g)&&o.expanded||(o.ul.style.display="none"),r&&a(o.ul).attr("role","group"),o.li?o.li.appendChild(o.ul):o.tree.$div.append(o.ul)),k=0,l=v.length;k<l;k++)n=a.extend({},c,{node:v[k]}),this.nodeRender(n,d,e,!1,!0);for(h=o.ul.firstChild;h;)j=h.ftnode,j&&j.parent!==o?(o.debug("_fixParent: remove missing "+j,h),m=h.nextSibling,h.parentNode.removeChild(h),h=m):h=h.nextSibling;for(h=o.ul.firstChild,k=0,l=v.length-1;k<l;k++)i=v[k],j=h.ftnode,i!==j?o.ul.insertBefore(i.li,j.li):h=h.nextSibling}}else o.ul&&(this.warn("remove child markup for "+o),this.nodeRemoveChildMarkup(c));u||s&&t.ul.insertBefore(o.li,w)}},nodeRenderTitle:function(b,c){var d,e,f,g,h,i,j,k=b.node,m=b.tree,n=b.options,o=n.aria,p=k.getLevel(),q=[];void 0!==c&&(k.title=c),k.span&&m._enableUpdate!==!1&&(h=o&&k.hasChildren()!==!1?" role='button'":"",p<n.minExpandLevel?(k.lazy||(k.expanded=!0),p>1&&q.push("<span "+h+" class='fancytree-expander fancytree-expander-fixed'></span>")):q.push("<span "+h+" class='fancytree-expander'></span>"),d=s.evalOption("checkbox",k,k,n,!1),d&&!k.isStatusNode()&&(h=o?" role='checkbox'":"",e="fancytree-checkbox",("radio"===d||k.parent&&k.parent.radiogroup)&&(e+=" fancytree-radio"),q.push("<span "+h+" class='"+e+"'></span>")),void 0!==k.data.iconClass&&(k.icon?a.error("'iconClass' node option is deprecated since v2.14.0: use 'icon' only instead"):(k.warn("'iconClass' node option is deprecated since v2.14.0: use 'icon' instead"),k.icon=k.data.iconClass)),f=s.evalOption("icon",k,k,n,!0),"boolean"!=typeof f&&(f=""+f),f!==!1&&(h=o?" role='presentation'":"","string"==typeof f?t.test(f)?(f="/"===f.charAt(0)?f:(n.imagePath||"")+f,q.push("<img src='"+f+"' class='fancytree-icon' alt='' />")):q.push("<span "+h+" class='fancytree-custom-icon "+f+"'></span>"):q.push("<span "+h+" class='fancytree-icon'></span>")),g="",n.renderTitle&&(g=n.renderTitle.call(m,{type:"renderTitle"},b)||""),g||(j=s.evalOption("tooltip",k,k,n,null),j===!0&&(j=k.title),j=j?" title='"+l(j)+"'":"",i=n.titlesTabbable?" tabindex='0'":"",g="<span class='fancytree-title'"+j+i+">"+(n.escapeTitles?s.escapeHtml(k.title):k.title)+"</span>"),q.push(g),k.span.innerHTML=q.join(""),this.nodeRenderStatus(b),n.enhanceTitle&&(b.$title=a(">span.fancytree-title",k.span),g=n.enhanceTitle.call(m,{type:"enhanceTitle"},b)||""))},nodeRenderStatus:function(b){var c,d=b.node,e=b.tree,f=b.options,g=d.hasChildren(),h=d.isLastSibling(),i=f.aria,j=f._classNames,k=[],l=d[e.statusClassPropName];l&&e._enableUpdate!==!1&&(i&&(c=a(d.tr||d.li)),k.push(j.node),e.activeNode===d&&k.push(j.active),e.focusNode===d&&k.push(j.focused),d.expanded&&k.push(j.expanded),i&&(g!==!1?c.attr("aria-expanded",Boolean(d.expanded)):c.removeAttr("aria-expanded")),d.folder&&k.push(j.folder),g!==!1&&k.push(j.hasChildren),h&&k.push(j.lastsib),d.lazy&&null==d.children&&k.push(j.lazy),d.partload&&k.push(j.partload),d.partsel&&k.push(j.partsel),s.evalOption("unselectable",d,d,f,!1)&&k.push(j.unselectable),d._isLoading&&k.push(j.loading),d._error&&k.push(j.error),d.statusNodeType&&k.push(j.statusNodePrefix+d.statusNodeType),d.selected?(k.push(j.selected),i&&c.attr("aria-selected",!0)):i&&c.attr("aria-selected",!1),d.extraClasses&&k.push(d.extraClasses),g===!1?k.push(j.combinedExpanderPrefix+"n"+(h?"l":"")):k.push(j.combinedExpanderPrefix+(d.expanded?"e":"c")+(d.lazy&&null==d.children?"d":"")+(h?"l":"")),k.push(j.combinedIconPrefix+(d.expanded?"e":"c")+(d.folder?"f":"")),l.className=k.join(" "),d.li&&a(d.li).toggleClass(j.lastsib,h))},nodeSetActive:function(c,d,e){e=e||{};var f,g=c.node,j=c.tree,k=c.options,l=e.noEvents===!0,m=e.noFocus===!0,n=g===j.activeNode;return d=d!==!1,n===d?h(g):d&&!l&&this._triggerNodeEvent("beforeActivate",g,c.originalEvent)===!1?i(g,["rejected"]):(d?(j.activeNode&&(b(j.activeNode!==g,"node was active (inconsistency)"),f=a.extend({},c,{node:j.activeNode}),j.nodeSetActive(f,!1),b(null===j.activeNode,"deactivate was out of sync?")),k.activeVisible&&g.makeVisible({scrollIntoView:m&&null==j.focusNode}),j.activeNode=g,j.nodeRenderStatus(c),m||j.nodeSetFocus(c),l||j._triggerNodeEvent("activate",g,c.originalEvent)):(b(j.activeNode===g,"node was not active (inconsistency)"),j.activeNode=null,this.nodeRenderStatus(c),l||c.tree._triggerNodeEvent("deactivate",g,c.originalEvent)),h(g))},nodeSetExpanded:function(b,c,d){d=d||{};var e,f,g,j,k,l,m=b.node,n=b.tree,o=b.options,p=d.noAnimation===!0,q=d.noEvents===!0;if(c=c!==!1,m.expanded&&c||!m.expanded&&!c)return h(m);if(c&&!m.lazy&&!m.hasChildren())return h(m);if(!c&&m.getLevel()<o.minExpandLevel)return i(m,["locked"]);if(!q&&this._triggerNodeEvent("beforeExpand",m,b.originalEvent)===!1)return i(m,["rejected"]);if(p||m.isVisible()||(p=d.noAnimation=!0),f=new a.Deferred,c&&!m.expanded&&o.autoCollapse){k=m.getParentList(!1,!0),l=o.autoCollapse;try{for(o.autoCollapse=!1,g=0,j=k.length;g<j;g++)this._callHook("nodeCollapseSiblings",k[g],d)}finally{o.autoCollapse=l}}return f.done(function(){var a=m.getLastChild();c&&o.autoScroll&&!p&&a?a.scrollIntoView(!0,{topNode:m}).always(function(){q||b.tree._triggerNodeEvent(c?"expand":"collapse",b)}):q||b.tree._triggerNodeEvent(c?"expand":"collapse",b)}),e=function(d){var e,f,g=o._classNames,h=o.toggleEffect;if(m.expanded=c,n._callHook("nodeRender",b,!1,!1,!0),m.ul)if(e="none"!==m.ul.style.display,f=!!m.expanded,e===f)m.warn("nodeSetExpanded: UL.style.display already set");else{if(h&&!p)return a(m.li).addClass(g.animating),void a(m.ul).addClass(g.animating).toggle(h.effect,h.options,h.duration,function(){a(this).removeClass(g.animating),a(m.li).removeClass(g.animating),d()});m.ul.style.display=m.expanded||!parent?"":"none"}d()},c&&m.lazy&&void 0===m.hasChildren()?m.load().done(function(){f.notifyWith&&f.notifyWith(m,["loaded"]),e(function(){f.resolveWith(m)})}).fail(function(a){e(function(){f.rejectWith(m,["load failed ("+a+")"])})}):e(function(){f.resolveWith(m)}),f.promise()},nodeSetFocus:function(b,c){var d,e=b.tree,f=b.node,g=e.options,h=!!b.originalEvent&&a(b.originalEvent.target).is(":input");if(c=c!==!1,e.focusNode){if(e.focusNode===f&&c)return;d=a.extend({},b,{node:e.focusNode}),e.focusNode=null,this._triggerNodeEvent("blur",d),this._callHook("nodeRenderStatus",d)}c&&(this.hasFocus()||(f.debug("nodeSetFocus: forcing container focus"),this._callHook("treeSetFocus",b,!0,{calledByNode:!0})),f.makeVisible({scrollIntoView:!1}),e.focusNode=f,g.titlesTabbable?h||a(f.span).find(".fancytree-title").focus():0===a(document.activeElement).closest(".fancytree-container").length&&a(e.$container).focus(),g.aria&&a(e.$container).attr("aria-activedescendant",a(f.tr||f.li).uniqueId().attr("id")),this._triggerNodeEvent("focus",b),g.autoScroll&&f.scrollIntoView(),this._callHook("nodeRenderStatus",b))},nodeSetSelected:function(a,b,c){c=c||{};var d=a.node,e=a.tree,f=a.options,g=c.noEvents===!0,h=d.parent;if(b=b!==!1,!s.evalOption("unselectable",d,d,f,!1)){if(d._lastSelectIntent=b,!!d.selected===b&&(3!==f.selectMode||!d.partsel||b))return b;if(!g&&this._triggerNodeEvent("beforeSelect",d,a.originalEvent)===!1)return!!d.selected;b&&1===f.selectMode?(e.lastSelectedNode&&e.lastSelectedNode.setSelected(!1),d.selected=b):3!==f.selectMode||!h||h.radiogroup||d.radiogroup?h&&h.radiogroup?d.visitSiblings(function(a){a._changeSelectStatusAttrs(b&&a===d)},!0):d.selected=b:(d.selected=b,d.fixSelection3AfterClick(c)),this.nodeRenderStatus(a),e.lastSelectedNode=b?d:null,g||e._triggerNodeEvent("select",a)}},nodeSetStatus:function(b,c,d,e){function f(){var a=h.children?h.children[0]:null;if(a&&a.isStatusNode()){try{h.ul&&(h.ul.removeChild(a.li),a.li=null)}catch(b){}1===h.children.length?h.children=[]:h.children.shift()}}function g(b,c){var d=h.children?h.children[0]:null;return d&&d.isStatusNode()?(a.extend(d,b),d.statusNodeType=c,i._callHook("nodeRenderTitle",d)):(h._setChildren([b]),h.children[0].statusNodeType=c,i.render()),h.children[0]}var h=b.node,i=b.tree;switch(c){case"ok":f(),h._isLoading=!1,h._error=null,h.renderStatus();break;case"loading":h.parent||g({title:i.options.strings.loading+(d?" ("+d+")":""),checkbox:!1,tooltip:e},c),h._isLoading=!0,h._error=null,h.renderStatus();break;case"error":g({title:i.options.strings.loadError+(d?" ("+d+")":""),checkbox:!1,tooltip:e},c),h._isLoading=!1,h._error={message:d,details:e},h.renderStatus();break;case"nodata":g({title:i.options.strings.noData,checkbox:!1,tooltip:e},c),h._isLoading=!1,h._error=null,h.renderStatus();break;default:a.error("invalid node status "+c)}},nodeToggleExpanded:function(a){return this.nodeSetExpanded(a,!a.node.expanded)},nodeToggleSelected:function(a){var b=a.node,c=!b.selected;return b.partsel&&!b.selected&&b._lastSelectIntent===!0&&(c=!1,b.selected=!0),b._lastSelectIntent=c,this.nodeSetSelected(a,c)},treeClear:function(a){var b=a.tree;b.activeNode=null,b.focusNode=null,b.$div.find(">ul.fancytree-container").empty(),b.rootNode.children=null},treeCreate:function(a){},treeDestroy:function(a){this.$div.find(">ul.fancytree-container").remove(),this.$source&&this.$source.removeClass("ui-helper-hidden")},treeInit:function(a){var b=a.tree,c=b.options;b.$container.attr("tabindex",c.tabindex),c.rtl?b.$container.attr("DIR","RTL").addClass("fancytree-rtl"):b.$container.removeAttr("DIR").removeClass("fancytree-rtl"),c.aria&&(b.$container.attr("role","tree"),1!==c.selectMode&&b.$container.attr("aria-multiselectable",!0)),this.treeLoad(a)},treeLoad:function(c,d){var e,f,g,h,i=c.tree,j=c.widget.element,l=a.extend({},c,{node:this.rootNode});if(i.rootNode.children&&this.treeClear(c),d=d||this.options.source)"string"==typeof d&&a.error("Not implemented");else switch(f=j.data("type")||"html"){case"html":g=j.find(">ul:first"),g.addClass("ui-fancytree-source ui-helper-hidden"),d=a.ui.fancytree.parseHtml(g),this.data=a.extend(this.data,k(g));break;case"json":d=a.parseJSON(j.text()),j.contents().filter(function(){return 3===this.nodeType}).remove(),a.isPlainObject(d)&&(b(a.isArray(d.children),"if an object is passed as source, it must contain a 'children' array (all other properties are added to 'tree.data')"),e=d,d=d.children,delete e.children,a.extend(i.data,e));break;default:a.error("Invalid data-type: "+f)}return h=this.nodeLoadChildren(l,d).done(function(){i.render(),3===c.options.selectMode&&i.rootNode.fixSelection3FromEndNodes(),i.activeNode&&i.options.activeVisible&&i.activeNode.makeVisible(),i._triggerTreeEvent("init",null,{status:!0})}).fail(function(){i.render(),i._triggerTreeEvent("init",null,{status:!1})})},treeRegisterNode:function(a,b,c){},treeSetFocus:function(b,c,d){var e;c=c!==!1,c!==this.hasFocus()&&(this._hasFocus=c,!c&&this.focusNode?this.focusNode.setFocus(!1):!c||d&&d.calledByNode||a(this.$container).focus(),this.$container.toggleClass("fancytree-treefocus",c),this._triggerTreeEvent(c?"focusTree":"blurTree"),c&&!this.activeNode&&(e=this._lastMousedownNode||this.getFirstChild(),e&&e.setFocus()))},treeSetOption:function(b,c,d){var e=b.tree,f=!0,g=!1,h=!1;switch(c){case"aria":case"checkbox":case"icon":case"minExpandLevel":case"tabindex":g=!0,h=!0;break;case"escapeTitles":case"tooltip":h=!0;break;case"rtl":d===!1?e.$container.removeAttr("DIR").removeClass("fancytree-rtl"):e.$container.attr("DIR","RTL").addClass("fancytree-rtl"),h=!0;break;case"source":f=!1,e._callHook("treeLoad",e,d),h=!0}e.debug("set option "+c+"="+d+" <"+typeof d+">"),f&&(this.widget._super?this.widget._super.call(this.widget,c,d):a.Widget.prototype._setOption.call(this.widget,c,d)),g&&e._callHook("treeCreate",e),h&&e.render(!0,!1)}}),a.widget("ui.fancytree",{options:{activeVisible:!0,ajax:{type:"GET",cache:!1,dataType:"json"},aria:!0,autoActivate:!0,autoCollapse:!1,autoScroll:!1,checkbox:!1,clickFolderMode:4,debugLevel:null,disabled:!1,enableAspx:!0,escapeTitles:!1,extensions:[],toggleEffect:{effect:"blind",options:{direction:"vertical",scale:"box"},duration:200},generateIds:!1,icon:!0,idPrefix:"ft_",focusOnSelect:!1,keyboard:!0,keyPathSeparator:"/",minExpandLevel:1,quicksearch:!1,rtl:!1,scrollOfs:{top:0,bottom:0},scrollParent:null,selectMode:2,strings:{loading:"Loading...",loadError:"Load error!",moreData:"More...",noData:"No data."},tabindex:"0",titlesTabbable:!1,tooltip:!1,_classNames:{node:"fancytree-node",folder:"fancytree-folder",animating:"fancytree-animating",combinedExpanderPrefix:"fancytree-exp-",combinedIconPrefix:"fancytree-ico-",hasChildren:"fancytree-has-children",active:"fancytree-active",selected:"fancytree-selected",expanded:"fancytree-expanded",lazy:"fancytree-lazy",focused:"fancytree-focused",partload:"fancytree-partload",partsel:"fancytree-partsel",radio:"fancytree-radio",unselectable:"fancytree-unselectable",lastsib:"fancytree-lastsib",loading:"fancytree-loading",error:"fancytree-error",statusNodePrefix:"fancytree-statusnode-"},lazyLoad:null,postProcess:null},_create:function(){this.tree=new p(this),this.$source=this.source||"json"===this.element.data("type")?this.element:this.element.find(">ul:first");var c,d,e,f=this.options,h=f.extensions,i=this.tree;for(e=0;e<h.length;e++)d=h[e],c=a.ui.fancytree._extensions[d],c||a.error("Could not apply extension '"+d+"' (it is not registered, did you forget to include it?)"),this.tree.options[d]=a.extend(!0,{},c.options,this.tree.options[d]),b(void 0===this.tree.ext[d],"Extension name must not exist as Fancytree.ext attribute: '"+d+"'"),this.tree.ext[d]={},g(this.tree,i,c,d),i=c;void 0!==f.icons&&(f.icon!==!0?a.error("'icons' tree option is deprecated since v2.14.0: use 'icon' only instead"):(this.tree.warn("'icons' tree option is deprecated since v2.14.0: use 'icon' instead"),f.icon=f.icons)),void 0!==f.iconClass&&(f.icon?a.error("'iconClass' tree option is deprecated since v2.14.0: use 'icon' only instead"):(this.tree.warn("'iconClass' tree option is deprecated since v2.14.0: use 'icon' instead"),f.icon=f.iconClass)),void 0!==f.tabbable&&(f.tabindex=f.tabbable?"0":"-1",this.tree.warn("'tabbable' tree option is deprecated since v2.17.0: use 'tabindex='"+f.tabindex+"' instead")),this.tree._callHook("treeCreate",this.tree)},_init:function(){this.tree._callHook("treeInit",this.tree),this._bind()},_setOption:function(a,b){return this.tree._callHook("treeSetOption",this.tree,a,b)},destroy:function(){this._unbind(),this.tree._callHook("treeDestroy",this.tree),a.Widget.prototype.destroy.call(this)},_unbind:function(){var b=this.tree._ns;this.element.off(b),this.tree.$container.off(b),a(document).off(b)},_bind:function(){var b=this,c=this.options,d=this.tree,e=d._ns;this._unbind(),d.$container.on("focusin"+e+" focusout"+e,function(b){var c=s.getNode(b),e="focusin"===b.type;c?d._callHook("nodeSetFocus",d._makeHookContext(c,b),e):d.tbody&&a(b.target).parents("table.fancytree-container > thead").length?d.debug("Ignore focus event outside table body.",b):d._callHook("treeSetFocus",d,e)}).on("selectstart"+e,"span.fancytree-title",function(a){a.preventDefault()}).on("keydown"+e,function(a){if(c.disabled||c.keyboard===!1)return!0;var b,e=d.focusNode,f=d._makeHookContext(e||d,a),g=d.phase;try{return d.phase="userEvent",b=e?d._triggerNodeEvent("keydown",e,a):d._triggerTreeEvent("keydown",a),"preventNav"===b?b=!0:b!==!1&&(b=d._callHook("nodeKeydown",f)),b}finally{d.phase=g}}).on("mousedown"+e,function(a){var c=s.getEventTarget(a);b.tree._lastMousedownNode=c?c.node:null}).on("click"+e+" dblclick"+e,function(a){if(c.disabled)return!0;var d,e=s.getEventTarget(a),f=e.node,g=b.tree,h=g.phase;if(!f)return!0;d=g._makeHookContext(f,a);try{switch(g.phase="userEvent",a.type){case"click":return d.targetType=e.type,f.isPagingNode()?g._triggerNodeEvent("clickPaging",d,a)===!0:g._triggerNodeEvent("click",d,a)!==!1&&g._callHook("nodeClick",d);case"dblclick":return d.targetType=e.type,g._triggerNodeEvent("dblclick",d,a)!==!1&&g._callHook("nodeDblclick",d)}}finally{g.phase=h}})},getActiveNode:function(){return this.tree.activeNode},getNodeByKey:function(a){return this.tree.getNodeByKey(a)},getRootNode:function(){return this.tree.rootNode},getTree:function(){return this.tree}}),s=a.ui.fancytree,a.extend(a.ui.fancytree,{version:"2.25.0",buildType: "production",debugLevel: 1,_nextId:1,_nextNodeKey:1,_extensions:{},_FancytreeClass:p,_FancytreeNodeClass:o,jquerySupports:{positionMyOfs:e(a.ui.version,1,9)},assert:function(a,c){return b(a,c)},createTree:function(b,c){var d=a(b).fancytree(c).fancytree("getTree");return d},debounce:function(a,b,c,d){var e;return 3===arguments.length&&"boolean"!=typeof c&&(d=c,c=!1),function(){var f=arguments;d=d||this,c&&!e&&b.apply(d,f),clearTimeout(e),e=setTimeout(function(){c||b.apply(d,f),e=null},a)}},debug:function(b){a.ui.fancytree.debugLevel>=2&&c("log",arguments)},error:function(a){c("error",arguments)},escapeHtml:function(a){return(""+a).replace(u,function(a){return x[a]})},fixPositionOptions:function(b){if((b.offset||(""+b.my+b.at).indexOf("%")>=0)&&a.error("expected new position syntax (but '%' is not supported)"),!a.ui.fancytree.jquerySupports.positionMyOfs){var c=/(\w+)([+-]?\d+)?\s+(\w+)([+-]?\d+)?/.exec(b.my),d=/(\w+)([+-]?\d+)?\s+(\w+)([+-]?\d+)?/.exec(b.at),e=(c[2]?+c[2]:0)+(d[2]?+d[2]:0),f=(c[4]?+c[4]:0)+(d[4]?+d[4]:0);b=a.extend({},b,{my:c[1]+" "+c[3],at:d[1]+" "+d[3]}),(e||f)&&(b.offset=""+e+" "+f)}return b},getEventTarget:function(b){var c=b&&b.target?b.target.className:"",d={node:this.getNode(b.target),type:void 0};return/\bfancytree-title\b/.test(c)?d.type="title":/\bfancytree-expander\b/.test(c)?d.type=d.node.hasChildren()===!1?"prefix":"expander":/\bfancytree-checkbox\b/.test(c)?d.type="checkbox":/\bfancytree(-custom)?-icon\b/.test(c)?d.type="icon":/\bfancytree-node\b/.test(c)?d.type="title":b&&b.target&&a(b.target).closest(".fancytree-title").length&&(d.type="title"),d},getEventTargetType:function(a){return this.getEventTarget(a).type},getNode:function(a){if(a instanceof o)return a;for(a instanceof jQuery?a=a[0]:void 0!==a.originalEvent&&(a=a.target);a;){if(a.ftnode)return a.ftnode;a=a.parentNode}return null},getTree:function(b){var c;return b instanceof p?b:(void 0===b&&(b=0),"number"==typeof b?b=a(".fancytree-container").eq(b):"string"==typeof b?b=a(b).eq(0):void 0!==b.selector?b=b.eq(0):void 0!==b.originalEvent&&(b=a(b.target)),b=b.closest(":ui-fancytree"),c=b.data("ui-fancytree")||b.data("fancytree"),c?c.tree:null)},evalOption:function(b,c,d,e,f){var g,h,i=c.tree,j=e[b],k=d[b];return a.isFunction(j)?(g={node:c,tree:i,widget:i.widget,options:i.widget.options},h=j.call(i,{type:b},g),null==h&&(h=k)):h=null!=k?k:j,null==h&&(h=f),h},eventToString:function(a){var b=a.which,c=a.type,d=[];return a.altKey&&d.push("alt"),a.ctrlKey&&d.push("ctrl"),a.metaKey&&d.push("meta"),a.shiftKey&&d.push("shift"),"click"===c||"dblclick"===c?d.push(A[a.button]+c):y[b]||d.push(z[b]||String.fromCharCode(b).toLowerCase()),d.join("+")},info:function(b){a.ui.fancytree.debugLevel>=1&&c("info",arguments)},keyEventToString:function(a){return this.warn("keyEventToString() is deprecated: use eventToString()"),this.eventToString(a)},overrideMethod:function(b,c,d){var e,f=b[c]||a.noop;b[c]=function(){try{return e=this._super,this._super=f,d.apply(this,arguments)}finally{this._super=e}}},parseHtml:function(b){var c,d,e,f,g,h,i,j,l=b.find(">li"),m=[];return l.each(function(){var l,n,o=a(this),p=o.find(">span:first",this),q=p.length?null:o.find(">a:first"),r={tooltip:null,data:{}};for(p.length?r.title=p.html():q&&q.length?(r.title=q.html(),r.data.href=q.attr("href"),r.data.target=q.attr("target"),r.tooltip=q.attr("title")):(r.title=o.html(),g=r.title.search(/<ul/i),g>=0&&(r.title=r.title.substring(0,g))),r.title=a.trim(r.title),f=0,h=B.length;f<h;f++)r[B[f]]=void 0;for(c=this.className.split(" "),e=[],f=0,h=c.length;f<h;f++)d=c[f],C[d]?r[d]=!0:e.push(d);if(r.extraClasses=e.join(" "),i=o.attr("title"),i&&(r.tooltip=i),i=o.attr("id"),i&&(r.key=i),o.attr("hideCheckbox")&&(r.checkbox=!1),l=k(o),l&&!a.isEmptyObject(l)){for(n in F)l.hasOwnProperty(n)&&(l[F[n]]=l[n],delete l[n]);for(f=0,h=D.length;f<h;f++)i=D[f],j=l[i],null!=j&&(delete l[i],r[i]=j);a.extend(r.data,l)}b=o.find(">ul:first"),b.length?r.children=a.ui.fancytree.parseHtml(b):r.children=r.lazy?void 0:null,m.push(r)}),m},registerExtension:function(c){b(null!=c.name,"extensions must have a `name` property."),b(null!=c.version,"extensions must have a `version` property."),a.ui.fancytree._extensions[c.name]=c},unescapeHtml:function(a){var b=document.createElement("div");return b.innerHTML=a,0===b.childNodes.length?"":b.childNodes[0].nodeValue},warn:function(a){c("warn",arguments)}}),a.ui.fancytree});